<?xml version="1.0"?>
<config xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        xsi:noNamespaceSchemaLocation="urn:magento:framework:ObjectManager/etc/config.xsd">
    <preference for="RSHBIntech\Subscriptions\Api\Data\SubscriptionInterface"
                type="RSHBIntech\Subscriptions\Model\Subscription" />

    <preference for="RSHBIntech\Subscriptions\Api\SubscriptionRepositoryInterface"
                type="RSHBIntech\Subscriptions\Model\SubscriptionRepository" />

    <preference for="RSHBIntech\Subscriptions\Api\Data\SubscriptionSearchResultsInterface"
                type="RSHBIntech\Subscriptions\Api\SubscriptionSearchResults" />

    <preference for="RSHBIntech\Subscriptions\Api\Helper\MailerInterface"
                type="RSHBIntech\Subscriptions\Helper\Mailer" />

    <type name="Magento\Framework\Console\CommandList">
        <arguments>
            <argument name="commands" xsi:type="array">
                <item name="create" xsi:type="object">RSHBIntech\Subscriptions\Console\Command\CreateSubscription</item>
            </argument>
        </arguments>
    </type>

    <virtualType name="SubscriptionsReportDataProvider" type="Magento\Framework\View\Element\UiComponent\DataProvider\SearchResult">
        <arguments>
            <argument name="resourceModel" xsi:type="string">
                RSHBIntech\Subscriptions\Model\ResourceModel\Subscription\Collection
            </argument>
            <argument name="mainTable" xsi:type="string">subscriptions</argument>
        </arguments>
    </virtualType>

    <type name="Magento\Framework\View\Element\UiComponent\DataProvider\CollectionFactory">
        <arguments>
            <argument xsi:type="array">
                <item xsi:type="string" name="subscriptions_report_data_source">SubscriptionsReportDataProvider</item>
            </argument>
        </arguments>
    </type>
</config>
